LarianShelfName = "ModP"
LarianShelfIcon = "Diag.png"
LarianshelfTooltip = "Change data path"

#regular imports for general Maya functions Open Maya for extended functions
import maya.cmds as cmds
import maya.api.OpenMaya as omCmds
import pymel.core as pm

import maya.mel as mel

#GUI related imports regular maya gui is a nightmare to code
from PySide import QtCore, QtGui
from shiboken import wrapInstance
import maya.OpenMayaUI as omui

defaultScriptPath=""#used to save dataPath
GameDataPath = ""

#get maya main window to use as script ui parent
def maya_main_window():
    main_window_ptr = omui.MQtUtil.mainWindow()
    return wrapInstance(long(main_window_ptr), QtGui.QWidget)

def BrowsePath():
    print "Browse Here"
    try:
        newTargetPath = cmds.fileDialog2(fileMode=3)#file mode 3 allows for only directories
    except: #user Canceled
        return
    
    return newTargetPath[0]    

def ApplyPathChange(text):
    print "apply here"
    print text
    if text is None or len(text) is 0:
        QtGui.QMessageBox.warning(maya_main_window(), "Wrong Location", "Your path entry is empty. Won't save.",QtGui.QMessageBox.Ok)
        return
    if not os.path.isdir(text):
        QtGui.QMessageBox.warning(maya_main_window(), "Wrong Location", "Your path entry isn't a directory. Won't save.",QtGui.QMessageBox.Ok)
        return
    
    dataPathFile = defaultScriptPath+"/data.path"
    
    dataRead = open(dataPathFile, 'w')
    
    dataRead.write(text)
    
    dataRead.close()
    

#UI Defintion  
class CheckDialogUi(object):
    def setupUi(self, Dialog):
        Dialog.resize(380, 80)
        self.verticalLayout = QtGui.QVBoxLayout(Dialog)
        
        self.horizontalLayout = QtGui.QHBoxLayout(Dialog)
        self.verticalLayout.addLayout(self.horizontalLayout)
        
        self.lblBegin = QtGui.QLabel(Dialog)
        self.lblBegin.setGeometry(QtCore.QRect(20, 13, 46, 13))
        self.lblBegin.setText("Data Path")
        self.horizontalLayout.addWidget(self.lblBegin)
        
        self.txtName = QtGui.QLineEdit(Dialog)
        self.txtName.setGeometry(QtCore.QRect(60, 10, 131, 20))
        self.horizontalLayout.addWidget(self.txtName)
        
        self.BtnSearch = QtGui.QPushButton(Dialog)
        self.BtnSearch.setMaximumSize(QtCore.QSize(20, 20))
        self.BtnSearch.setText("P")
        self.horizontalLayout.addWidget(self.BtnSearch)

        
        self.BtnApply = QtGui.QPushButton(Dialog)
        self.BtnApply.setMinimumSize(QtCore.QSize(0, 30))
        self.BtnApply.setText("Apply Path Change")
        self.verticalLayout.addWidget(self.BtnApply)

#Window defintion
class checkWindow(QtGui.QDialog):
    def __init__(self, parent=None):

        super(checkWindow, self).__init__(parent)
        self.setWindowFlags(QtCore.Qt.Tool)
        self.ui = CheckDialogUi()
        
        
        
        self.ui.setupUi(self)
        self.setWindowTitle("Divinity Data Path")
        
        self.ui.txtName.setText(GameDataPath)
        
        self.ui.BtnSearch.clicked.connect(self.BrowseForPath)
        self.ui.BtnApply.clicked.connect(self.ApplyChange)
    
    def BrowseForPath(self):
        result = BrowsePath()
        print result
        self.ui.txtName.setText(result)
    def ApplyChange(self):
        ApplyPathChange(self.ui.txtName.text())  
   
        
#check if window exists already by trying to close it ignore any errors    
try:
    chksWin.close()
except:
    pass           


projectDirectory = cmds.workspace(q=True, rd=True)
scriptPathList = os.environ['MAYA_SCRIPT_PATH'].split(";")
#get the path for dataPath saving
for path in scriptPathList:
    if projectDirectory in path:
        defaultScriptPath = path


if os.path.exists(dataPathFile):        
    dataRead = open(dataPathFile, 'r')
        
    global GameDataPath
        
    GameDataPath = dataRead.readline()
        
    dataRead.close()

chksWin = checkWindow(parent=maya_main_window())
chksWin.show()  
                   