LarianShelfName = "XpV"
LarianShelfIcon = "mkAni.png"
LarianshelfTooltip = "Add export and engine properties"

#regular imports for general Maya functions Open Maya for extended functions
import maya.cmds as cmds
import maya.api.OpenMaya as omCmds
import pymel.core as pm

import maya.mel as mel

#GUI related imports regular maya gui is a nightmare to code
from PySide import QtCore, QtGui
from shiboken import wrapInstance
import maya.OpenMayaUI as omui

#get maya main window to use as script ui parent
def maya_main_window():
    main_window_ptr = omui.MQtUtil.mainWindow()
    return wrapInstance(long(main_window_ptr), QtGui.QWidget)


class AttributeSetUi(object):
    def setupUi(self, Dialog):
        Dialog.resize(258, 175)
        self.verticalLayout = QtGui.QVBoxLayout(Dialog)
        
        self.BtnMakeAnimated = QtGui.QPushButton(Dialog)
        self.BtnMakeAnimated.setMinimumSize(QtCore.QSize(0, 30))
        self.BtnMakeAnimated.setText("Make Unskinned Animated")
        self.verticalLayout.addWidget(self.BtnMakeAnimated)
        
        self.BtnMakeCloth = QtGui.QPushButton(Dialog)
        self.BtnMakeCloth.setMinimumSize(QtCore.QSize(0, 30))
        self.BtnMakeCloth.setText("Make Cloth Simmed")
        self.verticalLayout.addWidget(self.BtnMakeCloth)
        
        self.BtnMakeVertexColour = QtGui.QPushButton(Dialog)
        self.BtnMakeVertexColour.setMinimumSize(QtCore.QSize(0, 30))
        self.BtnMakeVertexColour.setText("Make Vertex Coloured")
        self.verticalLayout.addWidget(self.BtnMakeVertexColour)
        
        self.BtnMakeProxy = QtGui.QPushButton(Dialog)
        self.BtnMakeProxy.setMinimumSize(QtCore.QSize(0, 30))
        self.BtnMakeProxy.setText("Make Proxy Mesh")
        self.verticalLayout.addWidget(self.BtnMakeProxy)
        
        self.BtnMakeSingleObject = QtGui.QPushButton(Dialog)
        self.BtnMakeSingleObject.setMinimumSize(QtCore.QSize(0, 30))
        self.BtnMakeSingleObject.setText("Make Single Object")
        self.verticalLayout.addWidget(self.BtnMakeSingleObject)        

#Window defintion
class AttributeSetWindow(QtGui.QDialog):
    def __init__(self, parent=None):

        super(AttributeSetWindow, self).__init__(parent)
        self.setWindowFlags(QtCore.Qt.Tool)
        self.ui = AttributeSetUi()
        
        self.ui.setupUi(self)
        self.setWindowTitle("Export Variables")
        
        self.ui.BtnMakeAnimated.clicked.connect(lambda: setAttribute(False, True, False, False, False))
        self.ui.BtnMakeCloth.clicked.connect(lambda: setAttribute(True, False, False, False, False))
        self.ui.BtnMakeVertexColour.clicked.connect(lambda: setAttribute(False, False, False, False, True))
        self.ui.BtnMakeProxy.clicked.connect(lambda: setAttribute(False, False, False, True, False))
        self.ui.BtnMakeSingleObject.clicked.connect(lambda: setAttribute(False, False, True, False, False))


def setAttribute(AsCloth, AsAnim, AsSingle, AsProxy, AsColoured):

    print AsColoured
    
    selected = cmds.ls(selection=True)

    for obj in selected:
        
        if AsCloth or AsAnim or AsProxy or AsColoured:
            if not cmds.attributeQuery('UserDefinedProperties', node=obj ,exists=True):
                    cmds.select(obj)
                    cmds.addAttr(longName='UserDefinedProperties', dataType="string")
            if AsAnim:       
                cmds.setAttr(obj+'.UserDefinedProperties', 'Rigid = true', type ="string")
            if AsCloth:
                cmds.setAttr(obj+'.UserDefinedProperties', 'Cloth=1', type ="string")
            if AsProxy:
                cmds.setAttr(obj+'.UserDefinedProperties', 'MeshProxy', type ="string")
            if AsColoured:
                cmds.setAttr(obj+'.UserDefinedProperties', 'VertexColoured', type ="string")
                    
            shapes = cmds.listRelatives(children=True, shapes= True) 
            
            if not shapes is None:
                for shape in shapes:
                    if not cmds.attributeQuery('UserDefinedProperties', node=shape ,exists=True):
                        cmds.select(shape)
                        cmds.addAttr(longName='UserDefinedProperties', dataType="string")
                    
                    if AsAnim:
                        cmds.setAttr(shape+'.UserDefinedProperties', 'Rigid = true', type ="string")
                    if AsCloth:
                        cmds.setAttr(shape+'.UserDefinedProperties', 'Cloth=1', type ="string")
                    if AsProxy:
                        cmds.setAttr(shape+'.UserDefinedProperties', 'MeshProxy', type ="string")
                    if AsColoured:
                        cmds.setAttr(shape+'.UserDefinedProperties', 'VertexColoured', type ="string")
        
        
        
        
    if AsSingle:
            
        print "ullooo"
        root = ""
            
        #select dummy root
        sceneObjects = cmds.ls()
        for obj in sceneObjects:
            if cmds.objectType(obj) == 'joint':
                if 'Dummy_Root' in obj:
                    root = obj
                    break
            
        if not cmds.attributeQuery('MLEData', node=root ,exists=True):
            cmds.select(root)
            cmds.addAttr(longName='MLEData', dataType="string", hidden=True)

        cmds.setAttr(root+'.MLEData', 'Single = true', type ="string")
              
                    

try:
    attrWin.close()
except:
    pass           



attrWin = AttributeSetWindow(parent=maya_main_window())
attrWin.show() 