LarianShelfName = "XpP"
LarianShelfIcon = "mkBull.png"
LarianshelfTooltip = "Add physics properties"

#regular imports for general Maya functions Open Maya for extended functions
import maya.cmds as cmds
import maya.api.OpenMaya as omCmds
import pymel.core as pm

import maya.mel as mel

#GUI related imports regular maya gui is a nightmare to code
from PySide import QtCore, QtGui
from shiboken import wrapInstance
import maya.OpenMayaUI as omui

#get maya main window to use as script ui parent
def maya_main_window():
    main_window_ptr = omui.MQtUtil.mainWindow()
    return wrapInstance(long(main_window_ptr), QtGui.QWidget)


class AttributeSetUi(object):
    def setupUi(self, Dialog):
        Dialog.resize(258, 175)
        self.verticalLayout = QtGui.QVBoxLayout(Dialog)
        
        self.BtnMakeAnimated = QtGui.QPushButton(Dialog)
        self.BtnMakeAnimated.setMinimumSize(QtCore.QSize(0, 30))
        self.BtnMakeAnimated.setText("Kinematic Physics Mesh")
        self.verticalLayout.addWidget(self.BtnMakeAnimated)
        
        self.BtnMakeStatic = QtGui.QPushButton(Dialog)
        self.BtnMakeStatic.setMinimumSize(QtCore.QSize(0, 30))
        self.BtnMakeStatic.setText("Static Physics Mesh")
        self.verticalLayout.addWidget(self.BtnMakeStatic)

        

#Window defintion
class AttributeSetWindow(QtGui.QDialog):
    def __init__(self, parent=None):

        super(AttributeSetWindow, self).__init__(parent)
        self.setWindowFlags(QtCore.Qt.Tool)
        self.ui = AttributeSetUi()
        
        self.ui.setupUi(self)
        self.setWindowTitle("Export Variables")
        
        self.ui.BtnMakeAnimated.clicked.connect(lambda: setAttribute(True, False))
        self.ui.BtnMakeStatic.clicked.connect(lambda: setAttribute(False, True))

def setAttribute(AsKinematic, AsStatic):

    print AsKinematic
    print AsStatic
    
    selected = cmds.ls(selection=True)

    for obj in selected:
        
        if not cmds.attributeQuery('MLEData', node=obj ,exists=True):
            cmds.select(obj)
            cmds.addAttr(longName='MLEData', dataType="string", hidden=True)

        if AsStatic:
            cmds.setAttr(obj+'.MLEData', 'Phys=Static', type ="string")
        
        if AsKinematic:
            cmds.setAttr(obj+'.MLEData', 'Phys=Kinematic', type ="string")
                    

try:
    attrWin.close()
except:
    pass           



attrWin = AttributeSetWindow(parent=maya_main_window())
attrWin.show() 