#this file is a placeholder for start up shelf set up

#regular imports for general Maya functions Open Maya for extended functions
import maya.cmds as cmds
import maya.api.OpenMaya as omCmds
import maya.mel as mel
import maya.utils as mu

#GUI related imports regular maya gui is a nightmare to code
from PySide import QtCore, QtGui
from shiboken import wrapInstance
import maya.OpenMayaUI as omui

#python imports
import os
import sys
import imp
import stat
from distutils.dir_util import copy_tree
import subprocess
import shutil

#get maya main window to use as script ui parent
def maya_main_window():
    main_window_ptr = omui.MQtUtil.mainWindow()
    return wrapInstance(long(main_window_ptr), QtGui.QWidget)
   



#file help
iconFolder = "\ShelfIcons\\"
mainPath = os.environ['MAYA_APP_DIR']+ "/scripts/LarianStudiosModTools/" #Best guess for maya path install 

shelfName = "Larian_Mod_Tools"
endScript = False


#Shelf creation 
def createSettings():
    
    #Get all the python scripts
    if not endScript:
        scriptList = cmds.getFileList(folder=mainPath, filespec="*.py")
        
        parentShelf = mel.eval('global string $gShelfTopLevel; $tempVar = $gShelfTopLevel;')#need a global maya variable assignment returns the variable in MEL
        
        #delete the old version of the shelf
        if cmds.shelfLayout(shelfName ,exists=True):
            
            
            buttonsList = cmds.shelfLayout(shelfName, q=True, childArray=True) or []
                        
                    
            for button in buttonsList:
                cmds.deleteUI(button, control=True)
                
            
        else:
            # create the new shelf
            newShelf = cmds.shelfLayout(shelfName, cellWidth=33, cellHeight=33, parent=parentShelf)
        
        
        
        
        shelfChildNames = cmds.layout(parentShelf, q=True, childArray=True) or []
        
        
        
        i = 0
        for item in shelfChildNames:
            if item in shelfName:
                cmds.shelfTabLayout(parentShelf, edit=True, selectTabIndex=i+1)
            i=i+1
            
        
            
        
        #Loop through scripts get name and tooltip from file and create a shelf button on the new shelf
        for script in scriptList :
            if not 'userSetup' in script and not 'LarianToolbarSetup' in script:
                
                print script
                
                print mainPath+'/'+script
                
                scriptRead = open(mainPath+'/'+script,'r')
                
                lines = scriptRead.readlines()

                shelfLabel = ""
                shelfTooltip = ""
                shelfIcon = 'pythonFamily.png'
				
                for line in lines:
                    if 'LarianShelfName' in line:
                        shelfLabel = line[line.index('=')+1:]
                        shelfLabel = shelfLabel.strip()
                        shelfLabel = shelfLabel.replace('"', '')
                    if 'LarianShelfIcon' in line:
                        shelfIcon = line[line.index('=')+1:]
                        shelfIcon = shelfIcon.strip()
                        shelfIcon = shelfIcon.replace('"', '')
                        shelfIcon = mainPath+iconFolder+shelfIcon
                    if 'LarianshelfTooltip' in line:
                        shelfTooltip = line[line.index('=')+1:]
                        shelfTooltip = shelfTooltip.strip()
                        shelfTooltip = shelfTooltip.replace('"', '') 
                        break;
                        
                  
                
                scriptRead.seek(0)
                
                currShelfButtons = cmds.shelfLayout(shelfName, q=True, childArray=True) or []
                for button in currShelfButtons:
                    if cmds.control(button, q=True, exists=True):
                        if cmds.control(button, q=True, docTag=True) == script:
                            cmds.deleteUI(button, control=True)
                
                
                cmds.shelfButton(docTag=script, command= scriptRead.read(), image=shelfIcon, imageOverlayLabel = shelfLabel, annotation=shelfTooltip, parent= shelfName, enable=True,manage=True,visible=True, style= "iconAndTextVertical" )
                
        #shelf.mel bug fix
        shelves = cmds.shelfTabLayout(parentShelf, query=True, tabLabelIndex=True)
        for index, shelf in enumerate(shelves):
            cmds.optionVar(stringValue=('shelfName%d' % (index+1), str(shelf)))
            
        setUnits()



#set units for current file if possible
def setUnits():   
    
    cmds.currentUnit(linear='m') # setting units to meter for bullet issues

# Run script called by the local User setup
def run():  
    
    
    #delayed creation of shelf so shelf are already made by maya itself
    mu.executeDeferred(createSettings)
