from PySide import QtCore, QtGui
import maya.cmds as cmds

import subprocess


#from . import MLEUiExtensions

#MLEUiExtensions.HistoryList(Dialog)
#MLEUiExtensions.MLELayerList(Dialog)

#Custom list view to allow right click content check on layer list
class MLELayerList(QtGui.QListWidget):
    def __init__(self, parent):
        super(MLELayerList,self).__init__()
    
    def mousePressEvent(self, event):
        if event.type() == QtCore.QEvent.MouseButtonPress:
            pos = self.mapFromGlobal(QtGui.QCursor.pos())
            row = self.indexAt(pos).row()
            
            if event.button() == QtCore.Qt.RightButton:
                
                contentList = cmds.editDisplayLayerMembers(self.item(row).text(), q=True) or []
                
                menu = QtGui.QMenu(self)
                
                for items in contentList:
                    
                     menu.addAction(items)
                
                menu.exec_(event.globalPos())
                
            else:
                super(MLELayerList, self).mousePressEvent(event)
                
