
import sys
#import maya.standalone as st
#st.initialize(name='python')

#import maya.cmds as cmds
import subprocess

from PySide import QtCore, QtGui
import os
import math

import re


mayapath = 'C:/Program Files/Autodesk/Maya2015/bin/mayapy.exe'

filesToLoop = sys.argv[1] #obligatory should be a path to the file containing the file list

scriptToExecute = sys.argv[2] #obligatory script

scriptVariables = sys.argv[3].split('#') #is allowed to be empty

chunkLength = 100


def loopFiles(fileWithLoopList, scriptToExecute, scriptVariables):
    
    global mayapath
    
    #get the maya install directory to find the mayapy.py file
    paths = os.environ['PATH'].split(';')
    for path in paths:
        search_result = re.search('/Maya2015/bin', path)
        if search_result and not 'Cg' in path:
            mayapath = path + "/mayapy.exe"
    
    scriptErrors = []
    loopErrors = []
    scriptWarnings = []
    
    file = open(fileWithLoopList,'r')
    
    fileList = file.read()
    
    file.close()
    
    fileList = fileList.split('#')
    
    #print fileList
    
    #sys.stdout.write("HI I AM GOING TO LOOP THROUGH " + str(len(filesToLoop))+" FILES")
    
    progress = 0
    
    chunkCount = int(math.ceil(len(fileList)*1.0/chunkLength*1.0))
    
    if chunkCount < 1:
        chunkCount = 1
    
    processedFileCount = 0
    
    for i in xrange(0, chunkCount):
        
        progress = progress +1
        os.system('cls')
        sys.stdout.write("I AM NOW AT CHUNK " + str(progress) + " OF " + str(chunkCount)+"\n")
        
        processCount = chunkLength
        
        if len(fileList)-processedFileCount < processCount:
            processCount = len(fileList)-processedFileCount

        file = open(os.path.split(fileWithLoopList)[0] + "/chunk.txt", 'w+')
        
		
        for j in xrange(0, processCount):
            file.write(fileList[j+processedFileCount]+'#')
            
        file.close()
        
        processedFileCount = processedFileCount+processCount
        
        command = mayapath + ' ' + scriptToExecute + ' ' + fileList[0] + ' '
        
        for vars in scriptVariables:
            command = command + vars + ' '
            
        try:    
            mayaExecuter = subprocess.Popen(command, stderr=subprocess.PIPE)
                    
                    
            out, err = mayaExecuter.communicate()
                
            print mayaExecuter.returncode
                
            sys.stdout.write(out)
            sys.stdout.write(err)
        except Exception, e:
            print e
    
    os.remove(os.path.split(fileWithLoopList)[0] + "/chunk.txt")
    
   
    #sys.exit(0)

if filesToLoop is None or len(filesToLoop) <=0:
    sys.stderr.write("You need a file list to execute this script")
    sys.exit(-1)


if scriptToExecute is None or scriptToExecute is "" :
    sys.stderr.write("You need a target batch script to execute this script")
    sys.exit(-1)
    
    
loopFiles(filesToLoop, scriptToExecute, scriptVariables)
    